%define major 1
%define minor 0
%define fix 0

Name: nodever
Version: %{major}.%{minor}.%{fix}
Release: 4
License: MIT
Summary: Node.js Version Manager
BuildArch: noarch

Requires: bash
Requires: update-alternatives

Requires(post): update-alternatives
Requires(post): coreutils-gnu

Source0: nodever

%description
nodever is a shell script to control the effective node.js version.
nodever is a deprecated script for controlling the effective Node.js version.
Since version 1.0.0, nodever is simply a wrapper for update-alternatives, which
should be used instead.

%prep

%build

%install

mkdir -p %{buildroot}/%{_bindir}
chmod +x %{SOURCE0}
cp %{SOURCE0} %{buildroot}/%{_bindir}


%post -p %{_bindir}/bash
###############################################################################
# processing after the install
# $1 = 1: install
# $1 = 2+: upgrade
###############################################################################
# Manually set /QOpenSys/usr/bin symlinks
if [[ -e /QOpenSys/usr/bin/node ]]
then
  rm -f /QOpenSys/usr/bin/node /QOpenSys/usr/bin/npm
  ln -sf %{_bindir}/node /QOpenSys/usr/bin/node
  ln -sf %{_bindir}/npm /QOpenSys/usr/bin/npm
fi

# Get the currently linked version
nodeBin=/QOpenSys/pkgs/bin/node
currentNodeVersion=""

nodeMajorVersionRegex="/QOpenSys/pkgs/lib/nodejs([0-9]+)/bin"

# Determine if update-alternatives is already in use
if [[ -e "$nodeBin" ]]
then
  currentLink="$(%{_bindir}/readlink -e $nodeBin)"
  # Save off the current major version being used, so we can restore the link if
  # needed during our conversion to update-alternatives
  if [[ $currentLink =~ $nodeMajorVersionRegex ]]
  then
    currentNodeVersion=${BASH_REMATCH[1]}
    if [[ $(%{_bindir}/readlink $nodeBin) == "/QOpenSys/etc/alternatives/node" ]]
    then
      # Already using alternatives, nothing to do
      exit
    fi
  fi

  # Iterate through the list of Node.js versions currently installed. If we are
  # not yet using update-alternatives, convert existing link to do so and
  # register other versions of Node.js with update-alternatives
  for nodeBinDir in /QOpenSys/pkgs/lib/nodejs*/bin
  do
    if [[ -e "$nodeBinDir/node" ]]
    then
      if [[ $nodeBinDir =~ $nodeMajorVersionRegex ]]
      then
        majorVersion=${BASH_REMATCH[1]}
        %{_bindir}/alternatives --install %{_bindir}/node node $nodeBinDir/node ${majorVersion} \
          --slave %{_bindir}/npm npm $nodeBinDir/npm \
          --slave %{_bindir}/npx npx $nodeBinDir/npx \
          &> /dev/null
      fi
    fi
  done

  if [[ $currentNodeVersion ]]
  then
    %{_bindir}/alternatives --set node %{_libdir}/nodejs${currentNodeVersion}/bin/node
  fi
fi


%files
%defattr(-, qsys, *none)

%{_bindir}/nodever

%changelog
* Mon Mar 16 2020 Mark Irish <mirish@ibm.com> - 1.0.0
- Modify package to wrap update-alternatives

* Mon Mar 11 2019 - Xu Meng <mengxumx@cn.ibm.com>
- update to v0.0.10

* Thu Jan 17 2019 - Xu Meng <mengxumx@cn.ibm.com>
- add new option 'auto' to set the latest available nodejs

* Thu Aug 30 2018 - Jesse Gorzinski <jgorzinski@gmail.com>
- update /QOpenSys/usr/bin symlinks

* Thu Aug 23 2018 - Xu Meng <mengxumx@cn.ibm.com>
- let specific nodejs(not nodever) create the global links

* Thu Jul 12 2018 - Xu Meng <mengxumx@cn.ibm.com>
- make 'yum install nodejs' install nodejs8, not nodever

* Thu Jun 07 2018 - Xu Meng <mengxumx@cn.ibm.com>
- optimize nodever speed

* Wed May 30 2018 - Xu Meng <mengxumx@cn.ibm.com>
- update to v0.0.4

* Tue May 29 2018 - Xu Meng <mengxumx@cn.ibm.com>
- refine nodever logic

* Tue May 29 2018 - Deng Ai Li <dengaili@cn.ibm.com>
- update to v0.02

* Mon May 28 2018 - Deng Ai Li <dengaili@cn.ibm.com>
- Fix the 'yum upgrade' issue

* Tue May 15 2018 - Xu Meng <mengxumx@cn.ibm.com>
- refine the nodever script

* Mon May 14 2018 - Xu Meng <mengxumx@cn.ibm.com>
- nodejs version control support
